;********************************************************************
;          implementace 1-wire slave do mikroprocesoru AVR
;    (c) 2005 Ales Povalac, alpov@inMail.cz, http://www.alpov.net/
;********************************************************************


;********************************************************************
; obsluha funkcniho prikazu
;********************************************************************
; vyuziva registry:	A, addr, data, crc 
; inicializace:		FUNC_CMD_INIT
; tento kod pravdepodobne budete menit k dosazeni pozadovane funkce
;********************************************************************


.equ	CODE_CMD_READ = 0xBE	; 1-wire prikazy
.equ	CODE_CMD_WRITE = 0x4E


;--------------------------------------------------------------------
; FUNC_CMD - zpracovani funkcniho prikazu
;--------------------------------------------------------------------
FUNC_CMD:
	rcall	OW_READBYTE		; cteni scratchpad prikazu
	cpi	data,CODE_CMD_READ
	breq	FUNC_CMD_READ		; READ
	cpi	data,CODE_CMD_WRITE
	breq	FUNC_CMD_WRITE		; WRITE
	rjmp	OW_WAIT4RESET		; jinak cekej na reset


;--------------------------------------------------------------------
; FUNC_CMD_READ - cteni scratchpadu
;--------------------------------------------------------------------
FUNC_CMD_READ:
	clr	crc		; vynulovat crc
	in	data,PINA	; nacist port
	rcall	DOW_CRC		; vypocet crc
	rcall	OW_WRITEBYTE	; odeslat port
	ldi	data,VERSION	; verze programu
	rcall	DOW_CRC		; vypocet crc
	rcall	OW_WRITEBYTE	; odeslat verzi
	mov	data,crc
	rcall	OW_WRITEBYTE	; odeslat crc
	rjmp	OW_WAIT4RESET	; cekej na reset


;--------------------------------------------------------------------
; FUNC_CMD_WRITE - zapis scratchpadu
;--------------------------------------------------------------------
FUNC_CMD_WRITE:
	rcall	OW_READBYTE	; precist bajt
	ldi	addr,OUTPUTS
	out	EEAR,addr
	ldi	A,(1<<EERE)
	out	EECR,A
	in	A,EEDR		; presict vystupy z EEPROM
	com	A
	or	data,A		; na vstupy dat pullupy
	out	PORTA,data	; odeslat na port
	rjmp	OW_WAIT4RESET	; cekej na reset


;--------------------------------------------------------------------
; FUNC_CMD_INIT - inicializace vystupu
;--------------------------------------------------------------------
FUNC_CMD_INIT:
	ldi	addr,OUTPUTS
	out	EEAR,addr
	ldi	A,(1<<EERE)
	out	EECR,A
	in	A,EEDR			; presict vystupy z EEPROM
	out	DDRA,A			; nastavena cast PORTA na vystup
	com	A
	out	PORTA,A			; na vstupy dat pullupy

	ldi	A,~(1<<OWDATA)
	out	PORTB,A			; PORTB krome OWDATA nastavit pullupy
	ret
